Index: contrib/ntp/util/ntp-keygen-opts.def
===================================================================
--- contrib/ntp/util/ntp-keygen-opts.def	(revision 330566)
+++ contrib/ntp/util/ntp-keygen-opts.def	(revision 330631)
@@ -35,10 +35,10 @@
     descrip   = "certificate scheme";
     doc = <<-  _EndOfDoc_
 	scheme is one of
-	RSA-MD2, RSA-MD5, RSA-SHA, RSA-SHA1, RSA-MDC2, RSA-RIPEMD160,
+	RSA-MD2, RSA-MD5, RSA-MDC2, RSA-SHA, RSA-SHA1, RSA-RIPEMD160,
 	DSA-SHA, or DSA-SHA1.
 
-	Select the certificate message digest/signature encryption scheme.
+	Select the certificate signature encryption/message digest scheme.
 	Note that RSA schemes must be used with a RSA sign key and DSA
 	schemes must be used with a DSA sign key.  The default without
 	this option is RSA-MD5.
@@ -55,7 +55,7 @@
     doc = <<-  _EndOfDoc_
 	Select the cipher which is used to encrypt the files containing
 	private keys.  The default is three-key triple DES in CBC mode,
-	equivalent to "@code{-C des-ede3-cbc".  The openssl tool lists ciphers
+	equivalent to "@code{-C des-ede3-cbc}".  The openssl tool lists ciphers
 	available in "@code{openssl -h}" output.
 	_EndOfDoc_;
 };
@@ -68,8 +68,9 @@
     ifdef     = AUTOKEY;
     descrip   = "Write IFF or GQ identity keys";
     doc = <<-  _EndOfDoc_
-	Write the IFF or GQ client keys to the standard output.  This is
-	intended for automatic key distribution by mail.
+	Write the public parameters from the IFF or GQ client keys to
+	the standard output.
+	This is intended for automatic key distribution by email.
 	_EndOfDoc_;
 };
 
@@ -117,11 +118,11 @@
 	the file name of IFF, GQ, and MV client parameters files.  In
 	that role, the default is the host name if this option is not
 	provided.  The group name, if specified using @code{-i/--ident} or
-	using @code{-s/--subject-name} following an '@code{@}' character,
-	is also a part of the self-signed host certificate's subject and
-	issuer names in the form @code{host@group} and should match the
-	'@code{crypto ident}' or '@code{server ident}' configuration in
-	@code{ntpd}'s configuration file. 
+	using @code{-s/--subject-name} following an '@code{@@}' character,
+	is also a part of the self-signed host certificate subject and
+	issuer names in the form @code{host@@group} and should match the
+	'@code{crypto ident}' or '@code{server ident}' configuration in the
+	@code{ntpd} configuration file.
 	_EndOfDoc_;
 };
 
@@ -138,15 +139,6 @@
 };
 
 flag = {
-    value     = M;
-    name      = md5key;
-    descrip   = "generate MD5 keys";
-    doc = <<-  _EndOfDoc_
-	Generate MD5 keys, obsoleting any that may exist.
-	_EndOfDoc_;
-};
-
-flag = {
     value     = m;
     name      = modulus;
     arg-type  = number;
@@ -153,7 +145,7 @@
     arg-name  = modulus;
     arg-range = '256->2048';
     ifdef     = AUTOKEY;
-    descrip   = "modulus";
+    descrip   = "prime modulus";
     doc = <<-  _EndOfDoc_
 	The number of bits in the prime modulus.  The default is 512.
 	_EndOfDoc_;
@@ -160,6 +152,15 @@
 };
 
 flag = {
+    value     = M;
+    name      = md5key;
+    descrip   = "generate symmetric keys";
+    doc = <<-  _EndOfDoc_
+	Generate symmetric keys, obsoleting any that may exist.
+	_EndOfDoc_;
+};
+
+flag = {
     value     = P;
     name      = pvt-cert;
     ifdef     = AUTOKEY;
@@ -203,20 +204,6 @@
 };
 
 flag = {
-    value     = S;
-    name      = sign-key;
-    arg-type  = string;
-    arg-name  = sign;
-    ifdef     = AUTOKEY;
-    descrip   = "generate sign key (RSA or DSA)";
-    doc = <<-  _EndOfDoc_
-	Generate a new sign key of the designated type, obsoleting any
-	that may exist.  By default, the program uses the host key as the
-	sign key.
-	_EndOfDoc_;
-};
-
-flag = {
     value     = s;
     name      = subject-name;
     arg-type  = string;
@@ -225,12 +212,12 @@
     descrip   = "set host and optionally group name";
     doc = <<-  _EndOfDoc_
 	Set the Autokey host name, and optionally, group name specified
-	following an '@code{@}' character.  The host name is used in the file
+	following an '@code{@@}' character.  The host name is used in the file
 	name of generated host and signing certificates, without the
 	group name.  The host name, and if provided, group name are used
-	in @code{host@group} form for the host certificate's subject and issuer
-	fields.  Specifying '@code{-s @group}' is allowed, and results in
-	leaving the host name unchanged while appending @code{@group} to the
+	in @code{host@@group} form for the host certificate subject and issuer
+	fields.  Specifying '@code{-s @@group}' is allowed, and results in
+	leaving the host name unchanged while appending @code{@@group} to the
 	subject and issuer fields, as with @code{-i group}.  The group name, or
 	if not provided, the host name are also used in the file names
 	of IFF, GQ, and MV client parameter files.
@@ -238,6 +225,20 @@
 };
 
 flag = {
+    value     = S;
+    name      = sign-key;
+    arg-type  = string;
+    arg-name  = sign;
+    ifdef     = AUTOKEY;
+    descrip   = "generate sign key (RSA or DSA)";
+    doc = <<-  _EndOfDoc_
+	Generate a new sign key of the designated type, obsoleting any
+	that may exist.  By default, the program uses the host key as the
+	sign key.
+	_EndOfDoc_;
+};
+
+flag = {
     value     = T;
     name      = trusted-cert;
     ifdef     = AUTOKEY;
@@ -280,26 +281,29 @@
   ds-text	= <<- _END_PROG_MDOC_DESCRIP
 This program generates cryptographic data files used by the NTPv4
 authentication and identification schemes.
-It generates MD5 key files used in symmetric key cryptography.
-In addition, if the OpenSSL software library has been installed,
-it generates keys, certificate and identity files used in public key
-cryptography.
+It can generate message digest keys used in symmetric key cryptography and,
+if the OpenSSL software library has been installed, it can generate host keys,
+signing keys, certificates, and identity keys and parameters used in Autokey
+public key cryptography.
 These files are used for cookie encryption,
-digital signature and challenge/response identification algorithms
+digital signature, and challenge/response identification algorithms
 compatible with the Internet standard security infrastructure.
 .Pp
-All files are in PEM-encoded printable ASCII format,
-so they can be embedded as MIME attachments in mail to other sites
+The message digest symmetric keys file is generated in a format
+compatible with NTPv3.
+All other files are in PEM-encoded printable ASCII format,
+so they can be embedded as MIME attachments in email to other sites
 and certificate authorities.
 By default, files are not encrypted.
 .Pp
-When used to generate message digest keys, the program produces a file
-containing ten pseudo-random printable ASCII strings suitable for the
-MD5 message digest algorithm included in the distribution.
+When used to generate message digest symmetric keys, the program
+produces a file containing ten pseudo-random printable ASCII strings
+suitable for the MD5 message digest algorithm included in the
+distribution.
 If the OpenSSL library is installed, it produces an additional ten
-hex-encoded random bit strings suitable for the SHA1 and other message
-digest algorithms.
-The message digest keys file must be distributed and stored
+hex-encoded random bit strings suitable for SHA1, AES-128-CMAC, and
+other message digest algorithms.
+The message digest symmetric keys file must be distributed and stored
 using secure means beyond the scope of NTP itself.
 Besides the keys used for ordinary NTP associations, additional keys
 can be defined as passwords for the
@@ -319,31 +323,42 @@
 Some files used by this program are encrypted using a private password.
 The
 .Fl p
-option specifies the password for local encrypted files and the
+option specifies the read password for local encrypted files and the
 .Fl q
-option the password for encrypted files sent to remote sites.
+option the write password for encrypted files sent to remote sites.
 If no password is specified, the host name returned by the Unix
-.Fn gethostname
-function, normally the DNS name of the host is used.
+.Xr hostname 1
+command, normally the DNS name of the host, is used as the the default read
+password, for convenience.
+The
+.Nm
+program prompts for the password if it reads an encrypted file
+and the password is missing or incorrect.
+If an encrypted file is read successfully and
+no write password is specified, the read password is used
+as the write password by default.
 .Pp
 The
-.Ar pw
+.Cm pw
 option of the
-.Ar crypto
+.Ic crypto
+.Xr ntpd 1ntpdmdoc
 configuration command specifies the read
 password for previously encrypted local files.
-This must match the local password used by this program.
+This must match the local read password used by this program.
 If not specified, the host name is used.
-Thus, if files are generated by this program without password,
+Thus, if files are generated by this program without an explicit password,
 they can be read back by
-.Ar ntpd
-without password but only on the same host.
+.Xr ntpd 1ntpdmdoc
+without specifying an explicit password but only on the same host.
+If the write password used for encryption is specified as the host name,
+these files can be read by that host with no explicit password.
 .Pp
 Normally, encrypted files for each host are generated by that host and
 used only by that host, although exceptions exist as noted later on
 this page.
 The symmetric keys file, normally called
-.Ar ntp.keys ,
+.Pa ntp.keys ,
 is usually installed in
 .Pa /etc .
 Other files and links are usually installed in
@@ -350,191 +365,90 @@
 .Pa /usr/local/etc ,
 which is normally in a shared filesystem in
 NFS-mounted networks and cannot be changed by shared clients.
-The location of the keys directory can be changed by the
-.Ar keysdir
-configuration command in such cases.
-Normally, this is in
-.Pa /etc .
+In these cases, NFS clients can specify the files in another
+directory such as
+.Pa /etc
+using the
+.Ic keysdir
+.Xr ntpd 1ntpdmdoc
+configuration file command.
 .Pp
 This program directs commentary and error messages to the standard
 error stream
-.Ar stderr
+.Pa stderr
 and remote files to the standard output stream
-.Ar stdout
+.Pa stdout
 where they can be piped to other applications or redirected to files.
 The names used for generated files and links all begin with the
 string
-.Ar ntpkey
+.Pa ntpkey\&*
 and include the file type, generating host and filestamp,
 as described in the
-.Dq Cryptographic Data Files
+.Sx "Cryptographic Data Files"
 section below.
+
 .Ss Running the Program
-To test and gain experience with Autokey concepts, log in as root and
-change to the keys directory, usually
-.Pa /usr/local/etc 
-When run for the first time, or if all files with names beginning with
-.Ar ntpkey
-have been removed, use the
-.Nm
-command without arguments to generate a
-default RSA host key and matching RSA-MD5 certificate with expiration
-date one year hence.
-If run again without options, the program uses the
-existing keys and parameters and generates only a new certificate with
-new expiration date one year hence.
-.Pp
-Run the command on as many hosts as necessary.
-Designate one of them as the trusted host (TH) using
-.Nm
-with the
-.Fl T
-option and configure it to synchronize from reliable Internet servers.
-Then configure the other hosts to synchronize to the TH directly or
-indirectly.
-A certificate trail is created when Autokey asks the immediately
-ascendant host towards the TH to sign its certificate, which is then
-provided to the immediately descendant host on request.
-All group hosts should have acyclic certificate trails ending on the TH.
-.Pp
-The host key is used to encrypt the cookie when required and so must be
-RSA type.
-By default, the host key is also the sign key used to encrypt
-signatures.
-A different sign key can be assigned using the
-.Fl S
-option and this can be either RSA or DSA type.
-By default, the signature
-message digest type is MD5, but any combination of sign key type and
-message digest type supported by the OpenSSL library can be specified
-using the
-.Fl c
-option.
-The rules say cryptographic media should be generated with proventic
-filestamps, which means the host should already be synchronized before
-this program is run.
-This of course creates a chicken-and-egg problem
-when the host is started for the first time.
-Accordingly, the host time
-should be set by some other means, such as eyeball-and-wristwatch, at
-least so that the certificate lifetime is within the current year.
-After that and when the host is synchronized to a proventic source, the
-certificate should be re-generated.
-.Pp
-Additional information on trusted groups and identity schemes is on the
-.Dq Autokey Public-Key Authentication
-page.
-
-
-.Pp
-The
-.Xr ntpd 1ntpdmdoc
-configuration command
-.Ic crypto pw Ar password
-specifies the read password for previously encrypted files.
-The daemon expires on the spot if the password is missing
-or incorrect.
-For convenience, if a file has been previously encrypted,
-the default read password is the name of the host running
-the program.
-If the previous write password is specified as the host name,
-these files can be read by that host with no explicit password.
-
-.Pp
-File names begin with the prefix
-.Cm ntpkey_
-and end with the postfix
-.Ar _hostname.filestamp ,
-where
-.Ar hostname
-is the owner name, usually the string returned
-by the Unix gethostname() routine, and
-.Ar filestamp
-is the NTP seconds when the file was generated, in decimal digits.
-This both guarantees uniqueness and simplifies maintenance
-procedures, since all files can be quickly removed
-by a
-.Ic rm ntpkey\&*
-command or all files generated
-at a specific time can be removed by a
-.Ic rm
-.Ar \&*filestamp
-command.
-To further reduce the risk of misconfiguration,
-the first two lines of a file contain the file name
-and generation date and time as comments.
-.Pp
-All files are installed by default in the keys directory
-.Pa /usr/local/etc ,
-which is normally in a shared filesystem
-in NFS-mounted networks.
-The actual location of the keys directory
-and each file can be overridden by configuration commands,
-but this is not recommended.
-Normally, the files for each host are generated by that host
-and used only by that host, although exceptions exist
-as noted later on this page.
-.Pp
-Normally, files containing private values,
-including the host key, sign key and identification parameters,
-are permitted root read/write-only;
-while others containing public values are permitted world readable.
-Alternatively, files containing private values can be encrypted
-and these files permitted world readable,
-which simplifies maintenance in shared file systems.
-Since uniqueness is insured by the hostname and
-file name extensions, the files for a NFS server and
-dependent clients can all be installed in the same shared directory.
-.Pp
-The recommended practice is to keep the file name extensions
-when installing a file and to install a soft link
-from the generic names specified elsewhere on this page
-to the generated files.
-This allows new file generations to be activated simply
-by changing the link.
-If a link is present, ntpd follows it to the file name
-to extract the filestamp.
-If a link is not present,
-.Xr ntpd 1ntpdmdoc
-extracts the filestamp from the file itself.
-This allows clients to verify that the file and generation times
-are always current.
-The
-.Nm
-program uses the same timestamp extension for all files generated
-at one time, so each generation is distinct and can be readily
-recognized in monitoring data.
-.Ss Running the program
 The safest way to run the
 .Nm
 program is logged in directly as root.
-The recommended procedure is change to the keys directory,
-usually
+The recommended procedure is change to the
+.Ar keys
+directory, usually
 .Pa /usr/local/etc ,
 then run the program.
-When run for the first time,
-or if all
-.Cm ntpkey
-files have been removed,
-the program generates a RSA host key file and matching RSA-MD5 certificate file,
+.Pp
+To test and gain experience with Autokey concepts, log in as root and
+change to the
+.Ar keys
+directory, usually
+.Pa /usr/local/etc .
+When run for the first time, or if all files with names beginning with
+.Pa ntpkey\&*
+have been removed, use the
+.Nm
+command without arguments to generate a default
+.Cm RSA
+host key and matching
+.Cm RSA-MD5
+certificate file with expiration date one year hence,
 which is all that is necessary in many cases.
 The program also generates soft links from the generic names
 to the respective files.
-If run again, the program uses the same host key file,
-but generates a new certificate file and link.
+If run again without options, the program uses the
+existing keys and parameters and generates a new certificate file with
+new expiration date one year hence, and soft link.
 .Pp
-The host key is used to encrypt the cookie when required and so must be RSA type.
+The host key is used to encrypt the cookie when required and so must be
+.Cm RSA
+type.
 By default, the host key is also the sign key used to encrypt signatures.
 When necessary, a different sign key can be specified and this can be
-either RSA or DSA type.
-By default, the message digest type is MD5, but any combination
+either
+.Cm RSA
+or
+.Cm DSA
+type.
+By default, the message digest type is
+.Cm MD5 ,
+but any combination
 of sign key type and message digest type supported by the OpenSSL library
-can be specified, including those using the MD2, MD5, SHA, SHA1, MDC2
-and RIPE160 message digest algorithms.
+can be specified, including those using the
+.Cm AES128CMAC , MD2 , MD5 , MDC2 , SHA , SHA1
+and
+.Cm RIPE160
+message digest algorithms.
 However, the scheme specified in the certificate must be compatible
 with the sign key.
-Certificates using any digest algorithm are compatible with RSA sign keys;
-however, only SHA and SHA1 certificates are compatible with DSA sign keys.
+Certificates using any digest algorithm are compatible with
+.Cm RSA
+sign keys;
+however, only
+.Cm SHA
+and
+.Cm SHA1
+certificates are compatible with
+.Cm DSA
+sign keys.
 .Pp
 Private/public key files and certificates are compatible with
 other OpenSSL applications and very likely other libraries as well.
@@ -545,19 +459,19 @@
 as the other files, are probably not compatible with anything other than Autokey.
 .Pp
 Running the program as other than root and using the Unix
-.Ic su
+.Xr su 1
 command
 to assume root may not work properly, since by default the OpenSSL library
 looks for the random seed file
-.Cm .rnd
+.Pa .rnd
 in the user home directory.
 However, there should be only one
-.Cm .rnd ,
+.Pa .rnd ,
 most conveniently
 in the root directory, so it is convenient to define the
-.Cm $RANDFILE
+.Ev RANDFILE
 environment variable used by the OpenSSL library as the path to
-.Cm /.rnd .
+.Pa .rnd .
 .Pp
 Installing the keys as root might not work in NFS-mounted
 shared file systems, as NFS clients may not be able to write
@@ -567,7 +481,8 @@
 .Pa /etc
 using the
 .Ic keysdir
-command.
+.Xr ntpd 1ntpdmdoc
+configuration file command.
 There is no need for one client to read the keys and certificates
 of other clients or servers, as these data are obtained automatically
 by the Autokey protocol.
@@ -581,7 +496,6 @@
 as the subject and issuer fields, respectively, of the certificate.
 The owner name is also used for the host and sign key files,
 while the trusted name is used for the identity files.
-
 .Pp
 All files are installed by default in the keys directory
 .Pa /usr/local/etc ,
@@ -601,8 +515,11 @@
 Alternatively, files containing private values can be encrypted
 and these files permitted world readable,
 which simplifies maintenance in shared file systems.
-Since uniqueness is insured by the hostname and
-file name extensions, the files for a NFS server and
+Since uniqueness is insured by the
+.Ar hostname
+and
+.Ar filestamp
+file name extensions, the files for an NTP server and
 dependent clients can all be installed in the same shared directory.
 .Pp
 The recommended practice is to keep the file name extensions
@@ -611,99 +528,98 @@
 to the generated files.
 This allows new file generations to be activated simply
 by changing the link.
-If a link is present, ntpd follows it to the file name
-to extract the filestamp.
+If a link is present,
+.Xr ntpd 1ntpdmdoc
+follows it to the file name to extract the
+.Ar filestamp .
 If a link is not present,
 .Xr ntpd 1ntpdmdoc
-extracts the filestamp from the file itself.
+extracts the
+.Ar filestamp
+from the file itself.
 This allows clients to verify that the file and generation times
 are always current.
 The
 .Nm
-program uses the same timestamp extension for all files generated
+program uses the same
+.Ar filestamp
+extension for all files generated
 at one time, so each generation is distinct and can be readily
 recognized in monitoring data.
-.Ss Running the program
-The safest way to run the
+.Pp
+Run the command on as many hosts as necessary.
+Designate one of them as the trusted host (TH) using
 .Nm
-program is logged in directly as root.
-The recommended procedure is change to the keys directory,
-usually
-.Pa /usr/local/etc ,
-then run the program.
-When run for the first time,
-or if all
-.Cm ntpkey
-files have been removed,
-the program generates a RSA host key file and matching RSA-MD5 certificate file,
-which is all that is necessary in many cases.
-The program also generates soft links from the generic names
-to the respective files.
-If run again, the program uses the same host key file,
-but generates a new certificate file and link.
+with the
+.Fl T
+option and configure it to synchronize from reliable Internet servers.
+Then configure the other hosts to synchronize to the TH directly or
+indirectly.
+A certificate trail is created when Autokey asks the immediately
+ascendant host towards the TH to sign its certificate, which is then
+provided to the immediately descendant host on request.
+All group hosts should have acyclic certificate trails ending on the TH.
 .Pp
-The host key is used to encrypt the cookie when required and so must be RSA type.
-By default, the host key is also the sign key used to encrypt signatures.
-When necessary, a different sign key can be specified and this can be
-either RSA or DSA type.
-By default, the message digest type is MD5, but any combination
-of sign key type and message digest type supported by the OpenSSL library
-can be specified, including those using the MD2, MD5, SHA, SHA1, MDC2
-and RIPE160 message digest algorithms.
-However, the scheme specified in the certificate must be compatible
-with the sign key.
-Certificates using any digest algorithm are compatible with RSA sign keys;
-however, only SHA and SHA1 certificates are compatible with DSA sign keys.
+The host key is used to encrypt the cookie when required and so must be
+RSA type.
+By default, the host key is also the sign key used to encrypt
+signatures.
+A different sign key can be assigned using the
+.Fl S
+option and this can be either
+.Cm RSA
+or
+.Cm DSA
+type.
+By default, the signature
+message digest type is
+.Cm MD5 ,
+but any combination of sign key type and
+message digest type supported by the OpenSSL library can be specified
+using the
+.Fl c
+option.
 .Pp
-Private/public key files and certificates are compatible with
-other OpenSSL applications and very likely other libraries as well.
-Certificates or certificate requests derived from them should be compatible
-with extant industry practice, although some users might find
-the interpretation of X509v3 extension fields somewhat liberal.
-However, the identification parameter files, although encoded
-as the other files, are probably not compatible with anything other than Autokey.
+The rules say cryptographic media should be generated with proventic
+filestamps, which means the host should already be synchronized before
+this program is run.
+This of course creates a chicken-and-egg problem
+when the host is started for the first time.
+Accordingly, the host time
+should be set by some other means, such as eyeball-and-wristwatch, at
+least so that the certificate lifetime is within the current year.
+After that and when the host is synchronized to a proventic source, the
+certificate should be re-generated.
 .Pp
-Running the program as other than root and using the Unix
-.Ic su
-command
-to assume root may not work properly, since by default the OpenSSL library
-looks for the random seed file
-.Cm .rnd
-in the user home directory.
-However, there should be only one
-.Cm .rnd ,
-most conveniently
-in the root directory, so it is convenient to define the
-.Cm $RANDFILE
-environment variable used by the OpenSSL library as the path to
-.Cm /.rnd .
+Additional information on trusted groups and identity schemes is on the
+.Dq Autokey Public-Key Authentication
+page.
 .Pp
-Installing the keys as root might not work in NFS-mounted
-shared file systems, as NFS clients may not be able to write
-to the shared keys directory, even as root.
-In this case, NFS clients can specify the files in another
-directory such as
-.Pa /etc
-using the
-.Ic keysdir
+File names begin with the prefix
+.Pa ntpkey Ns _
+and end with the suffix
+.Pa _ Ns Ar hostname . Ar filestamp ,
+where
+.Ar hostname
+is the owner name, usually the string returned
+by the Unix
+.Xr hostname 1
+command, and
+.Ar filestamp
+is the NTP seconds when the file was generated, in decimal digits.
+This both guarantees uniqueness and simplifies maintenance
+procedures, since all files can be quickly removed
+by a
+.Ic rm Pa ntpkey\&*
+command or all files generated
+at a specific time can be removed by a
+.Ic rm Pa \&* Ns Ar filestamp
 command.
-There is no need for one client to read the keys and certificates
-of other clients or servers, as these data are obtained automatically
-by the Autokey protocol.
-.Pp
-Ordinarily, cryptographic files are generated by the host that uses them,
-but it is possible for a trusted agent (TA) to generate these files
-for other hosts; however, in such cases files should always be encrypted.
-The subject name and trusted name default to the hostname
-of the host generating the files, but can be changed by command line options.
-It is convenient to designate the owner name and trusted name
-as the subject and issuer fields, respectively, of the certificate.
-The owner name is also used for the host and sign key files,
-while the trusted name is used for the identity files.
-seconds.
-seconds.
+To further reduce the risk of misconfiguration,
+the first two lines of a file contain the file name
+and generation date and time as comments.
 
-s Trusted Hosts and Groups
+.Ss Trusted Hosts and Groups
 Each cryptographic configuration involves selection of a signature scheme
 and identification scheme, called a cryptotype,
 as explained in the
@@ -710,8 +626,14 @@
 .Sx Authentication Options
 section of
 .Xr ntp.conf 5 .
-The default cryptotype uses RSA encryption, MD5 message digest
-and TC identification.
+The default cryptotype uses
+.Cm RSA
+encryption,
+.Cm MD5
+message digest
+and
+.Cm TC
+identification.
 First, configure a NTP subnet including one or more low-stratum
 trusted hosts from which all other hosts derive synchronization
 directly or indirectly.
@@ -729,7 +651,7 @@
 .Pp
 On each trusted host as root, change to the keys directory.
 To insure a fresh fileset, remove all
-.Cm ntpkey
+.Pa ntpkey
 files.
 Then run
 .Nm
@@ -754,7 +676,9 @@
 .Cm RSA
 or
 .Cm DSA .
-The most often need to do this is when a DSA-signed certificate is used.
+The most frequent need to do this is when a
+.Cm DSA Ns -signed
+certificate is used.
 If it is necessary to use a different certificate scheme than the default,
 run
 .Nm
@@ -763,10 +687,10 @@
 option and selected
 .Ar scheme
 as needed.
-f
+If
 .Nm
 is run again without these options, it generates a new certificate
-using the same scheme and sign key.
+using the same scheme and sign key, and soft link.
 .Pp
 After setting up the environment it is advisable to update certificates
 from time to time, if only to extend the validity interval.
@@ -773,7 +697,7 @@
 Simply run
 .Nm
 with the same flags as before to generate new certificates
-using existing keys.
+using existing keys, and soft links.
 However, if the host or sign key is changed,
 .Xr ntpd 1ntpdmdoc
 should be restarted.
@@ -782,15 +706,18 @@
 is restarted, it loads any new files and restarts the protocol.
 Other dependent hosts will continue as usual until signatures are refreshed,
 at which time the protocol is restarted.
+
 .Ss Identity Schemes
 As mentioned on the Autonomous Authentication page,
-the default TC identity scheme is vulnerable to a middleman attack.
+the default
+.Cm TC
+identity scheme is vulnerable to a middleman attack.
 However, there are more secure identity schemes available,
-including PC, IFF, GQ and MV described on the
-.Qq Identification Schemes
-page
-(maybe available at
-.Li http://www.eecis.udel.edu/%7emills/keygen.html ) .
+including
+.Cm PC , IFF , GQ
+and
+.Cm MV
+schemes described below.
 These schemes are based on a TA, one or more trusted hosts
 and some number of nontrusted hosts.
 Trusted hosts prove identity using values provided by the TA,
@@ -815,12 +742,15 @@
 .Fl P
 .Fl p Ar password
 to generate the host key file
-.Pa ntpkey_RSAkey_ Ns Ar alice.filestamp
+.Pa ntpkey Ns _ Cm RSA Pa key_alice. Ar filestamp
 and trusted private certificate file
-.Pa ntpkey_RSA-MD5_cert_ Ns Ar alice.filestamp .
+.Pa ntpkey Ns _ Cm RSA-MD5 _ Pa cert_alice. Ar filestamp ,
+and soft links.
 Copy both files to all group hosts;
 they replace the files which would be generated in other schemes.
-On each host bob install a soft link from the generic name
+On each host
+.Ar bob
+install a soft link from the generic name
 .Pa ntpkey_host_ Ns Ar bob
 to the host key file and soft link
 .Pa ntpkey_cert_ Ns Ar bob
@@ -829,11 +759,17 @@
 by trusted host alice.
 In this scheme it is not possible to refresh
 either the keys or certificates without copying them
-to all other hosts in the group.
+to all other hosts in the group, and recreating the soft links.
 .Pp
-For the IFF scheme proceed as in the TC scheme to generate keys
+For the
+.Cm IFF
+scheme proceed as in the
+.Cm TC
+scheme to generate keys
 and certificates for all group hosts, then for every trusted host in the group,
-generate the IFF parameter file.
+generate the
+.Cm IFF
+parameter file.
 On trusted host alice run
 .Nm
 .Fl T
@@ -840,15 +776,17 @@
 .Fl I
 .Fl p Ar password
 to produce her parameter file
-.Pa ntpkey_IFFpar_ Ns Ar alice.filestamp ,
+.Pa ntpkey_IFFpar_alice. Ns Ar filestamp ,
 which includes both server and client keys.
 Copy this file to all group hosts that operate as both servers
 and clients and install a soft link from the generic
-.Pa ntpkey_iff_ Ns Ar alice
+.Pa ntpkey_iff_alice
 to this file.
 If there are no hosts restricted to operate only as clients,
 there is nothing further to do.
-As the IFF scheme is independent
+As the
+.Cm IFF
+scheme is independent
 of keys and certificates, these files can be refreshed as needed.
 .Pp
 If a rogue client has the parameter file, it could masquerade
